variables:
  DOCKERFILE: $CI_PROJECT_DIR/src/main/docker/Dockerfile.native-micro-multistage
  #DOCKERFILE: $CI_PROJECT_DIR/src/main/docker/Dockerfile.jvm-multistage
  helm_version: 3.12.2

include:
  - project: 'dariah-de/gitlab-templates'
    ref: 'main'
    file:
      - '/templates/TextGrid-Container-Build.gitlab-ci.yml'
      - '/templates/SBOM-Upload.gitlab-ci.yml'

# todo: tests now run on prepare stage, because native image build takes so long
# and the container-build-template does stuff with the container in test stage
stages:
  - prepare
  - build
  - test
  - deploy

# run checks and create artifacts like helmchart and sbom
test and create artifacts:
  image: gradle:jdk17
  stage: prepare
  script:
      # build also runs check, see https://docs.gradle.org/current/userguide/java_plugin.html#sec:java_tasks
      # -Prelease.ignoreUncommittedChanges=true may possibly only run on tags (?) for non-snapshot helm charts
      - gradle build
      #- awk -F"," '{ instructions += $4 + $5; covered += $5 } END { print covered, "/", instructions, " instructions covered"; print 100*covered/instructions, "% covered" }' build/jacoco-report/jacoco.csv
      - gradle cyclonedxBom
      - cp build/reports/bom.json .
  #coverage: /\d+.\d+ \% covered/
  artifacts:
    #reports:
    #  junit: build/test-results/test/TEST-*.xml
    paths:
      #- build/jacoco-report/
      - bom.json
      - build/helm/kubernetes/ebookportal
  cache:
    key: "$CI_COMMIT_REF_NAME"
    policy: pull
    paths:
      - build
      - .gradle

# TODO: we can remove this job later and set check for snapshotDependencies in build.gradle to true
snapshot warn:
  stage: prepare
  needs: []
  image: gradle:jdk17
  allow_failure: true
  script: |
    if [ `./gradlew dependencies | grep -c SNAPSHOT` -ge 1 ]; then
      echo "WARNING: snapshot dependency found. Move to stable versions before release."
      exit 1
    else
      echo "OK: no snapshot dependencies found."
      exit 0
    fi

pages:
  stage: deploy
  dependencies:
    - test and create artifacts
  script:
   - mkdir public
   #- mv build/jacoco-report public/coverage
  artifacts:
    paths:
      - public
  only:
    - tags

# shall run before update-changelog, but after checks
create release:
  stage: deploy
  image: gradle:jdk17
  script:
   - git remote set-url origin ${CI_SERVER_URL}/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git
   - ./gradlew release -Prelease.disableChecks -Prelease.pushTagsOnly -Prelease.overriddenBranchName=${CI_COMMIT_BRANCH} -Prelease.customUsername=${GL_USER} -Prelease.customPassword=${GL_TOKEN}
  only:
    - main

update changelog:
  image:
    name: quay.io/git-chglog/git-chglog:latest
    entrypoint: [""]
  dependencies:
    - create release
  stage: deploy
  before_script:
    - git remote set-url origin https://${GL_USER}:${GL_TOKEN}@${CI_SERVER_HOST}/${CI_PROJECT_NAMESPACE}/${CI_PROJECT_NAME}.git
    - git config --global user.name "${GL_USER}"
    - git config --global user.email "${GL_USER}@noreply.gitlab.gwdg.de"
    - git checkout main
    - git fetch --all
    - git reset --hard origin/main
  script:
    - git-chglog -o CHANGELOG.md
    - git add CHANGELOG.md
    - git commit -m 'edit CHANGELOG.md [skip ci]' || true
    - git push origin main || true
  only:
    - main

#publish helmchart:
#  image:
#    name: alpine/helm:${helm_version}
#    entrypoint: [""] # override entrypoint to use sh instead of starting helm directly
#  stage: deploy
#  before_script:
#    - helm registry login --username="${HARBOR_USER}" --password="${HARBOR_PASS}" harbor.gwdg.de
#  script:
#    - helm package build/helm/kubernetes/ebookportal
#    - helm push ebookportal*.tgz oci://harbor.gwdg.de/sub-fe
#  only:
#    - tags
